10 REM PATTERNS 5 : ABSTRACT PATTERNS
20 REM Written by A.Sill
30 REM In GWBASIC
40 REM (c) 1992
50 REM
60 SCREEN 9:CLS
70 A$="PATTERSN 5 - ABSTRACT PATTERNS"
80 COLOR 2
90 LOCATE 2,(80-LEN(A$))/2:PRINT A$
100 COLOR 10
110 COLOR 10:LOCATE 5,1:PRINT "    This extremely simplistic program is designed to show beginners how to use  the BASIC drawing commands. Comments are included in REM statements."
120 RAND=0
130 LOCATE 20,33:COLOR 12:PRINT "Press any key"
140 A$=""
150 A$=INKEY$:RAND=RAND+.1:IF A$="" THEN 150
160 RAND=RAND-VAL(RIGHT$(TIME$,2))
170 RANDOMIZE RAND
180 REM This is a simple routine to show you how to use circles and rectangles
190 CLS
200 FOR A=1 TO 500
210 X=INT(RND*500)+70:Y=INT(RND*300)+20
220 X1=INT(RND*50):Y1=INT(RND*50)
230 COLOUR%=INT(RND*15)+1
240 REM ++++++++++++ This command gives the variable COLOUR% a random value                          between 1 and 15
250 RANDOM%=INT(RND*2)
260 REM ++++++++++++ This picks a RANDOM number (either 1 or 0)
270 IF RANDOM%=1 THEN GOSUB 310 ELSE GOSUB 400
280 REM ++++++++++++ This statement picks either CIRCLE or RECTANGLE depending                       on the value in RANDOM%
290 NEXT A
300 STOP
310 REM Draw a circle
320 CIRCLE (X,Y),X1,COLOUR%
330 REM ++++++++++++ The X and Y are the cordinates of the centre of the circle
340 REM ++++++++++++ The X1 value is the radius value in pixels
350 REM ++++++++++++ COLOUR% tells it which colour to draw it in
360 PAINT (X,Y),COLOUR%
370 REM ++++++++++++ This commands fills the circle with it's COLOUR% value
380 REM ++++++++++++ The X and Y are the coordinates at which to start filling
390 RETURN
400 REM Draw a filled rectangle
410 LINE (X,Y)-(X+X1,Y+Y1),COLOUR%,BF
420 REM ++++++++++++ The X and Y are the top left hand coordinates of the box
430 REM ++++++++++++ The X1 and Y2 are the length and breadth of the box
440 REM ++++++++++++ As before the COLOUR% statement provides the colour
450 REM ++++++++++++ The B in the BF at the end signifies that a BOX is to be                        drawn, and the F signifies that it is to be filled as well
460 RETURN
470 REM ********* RETURN TO MENU POSER
480 CLS
490 COLOR 12:PRINT:PRINT:PRINT "          Do you want to 1. Run again or":PRINT "                         2. Return to DOS ?."
500 LOCATE 3,26:COLOR 7:PRINT "1"
510 LOCATE 4,26:PRINT "2"
520 A$=INKEY$:IF A$="" THEN GOTO 520
530 IF A$="1" THEN CLEAR:RUN
540 IF A$="2" THEN CLS:SYSTEM
550 GOTO 520
