10 REM UTILITY 2 : LEAGUE TRACKER
20 REM Written by A.Sill
30 REM In GWBASIC
40 REM (c) 1992
50 REM
60 DIM WINS%(24),LOSSES%(24),GFOR%(24),GAGAINST%(24),POINTS%(24),DRAWS%(24),SCORE%(24),POSITION%(24)
70 SCREEN 9:CLS
80 A$="UTILITY 2 : LEAGUE TRACKER"
90 COLOR 2
100 LOCATE 2,(80-LEN(A$))/2:PRINT A$
110 COLOR 10
120 COLOR 10:LOCATE 5,1:PRINT "     This program is a utility to track a leagues progress, by entering scores  you can keep an up to date league table."
130 RAND=0
140 LOCATE 20,33:COLOR 12:PRINT "Press any key"
150 A$=""
160 A$=INKEY$:RAND=RAND+.1:IF A$="" THEN 160
170 RAND=RAND-VAL(RIGHT$(TIME$,2))
180 RANDOMIZE RAND
190 REM
200 CLS
210 COLOR 2:LOCATE 2,32:PRINT "LEAGUE TRACKER"
220 COLOR 11:LOCATE 5,5:PRINT "Load a previously saved league (Y)es or (N)o ?"
230 A$=INKEY$:IF A$="" THEN GOTO 230
240 IF A$="Y" OR A$="y" THEN GOTO 400
250 IF A$="N" OR A$="n" THEN GOTO 270
260 GOTO 230
270 LOCATE 7,5:INPUT "How many teams are in the league (3-24) ";NUM
280 IF NUM<3 OR NUM>24 THEN GOTO 270
290 LOCATE 9,5:INPUT "Enter the name of the league :",LEAGUE$
300 IF LEAGUE$="" OR LEN(LEAGUE$)>60 THEN GOTO 290
310 LOCATE 11,5:INPUT "Do you wish to have those teams on equal points to be separated by (1) Goal     difference or (2) Highest number of goals ";SEP%
320 IF SEP%<>1 AND SEP%<>2 THEN GOTO 310
330 PRINT
340 FOR A=1 TO NUM
350 POSITION%(A)=A
360 PRINT "   Enter name of team ";A;:INPUT " ";TEAM$(A)
370 IF TEAM$(A)="" OR LEN(TEAM$(A))>25 THEN GOTO 360
380 NEXT A
390 GOTO 850
400 REM ++++++++ LOAD A LEAGUE ++++++++
410 CLS
420 LOCATE 2,30:PRINT "LOAD A SAVED LEAGUE"
430 LOCATE 5,5:INPUT "Enter filename :",F$
440 IF LEN(F$)>8 OR F$="" THEN GOTO 410
450 LOCATE 7,5:PRINT "Opening league file"
460 OPEN F$+".SVD" FOR INPUT AS #1
470 INPUT #1,LEAGUE$:INPUT #1,NUM:INPUT #1,SEP%
480 FOR A=1 TO NUM:INPUT #1,TEAM$(A):INPUT #1,WINS%(A):INPUT #1,DRAWS%(A):INPUT #1,LOSSES%(A):INPUT #1,POINTS%(A):INPUT #1,GFOR%(A):INPUT #1,GAGAINST%(A):INPUT #1,POSITION%(A):NEXT A
490 CLOSE
500 GOTO 570
510 REM ++++++++ ASSIGN POINTS ++++++++
520 GFOR%(H%)=GFOR%(H%)+HS%:GAGAINST%(H%)=GAGAINST%(H%)+AS%
530 GFOR%(A%)=GFOR%(A%)+AS%:GAGAINST%(A%)=GAGAINST%(A%)+HS%
540 IF HS%>AS% THEN POINTS%(H%)=POINTS%(H%)+3:WINS%(H%)=WINS%(H%)+1:LOSSES%(A%)=LOSSES%(A%)+1:GOTO 570
550 IF HS%<AS% THEN POINTS%(A%)=POINTS%(A%)+3:WINS%(A%)=WINS%(A%)+1:LOSSES%(H%)=LOSSES%(H%)+1:GOTO 570
560 IF HS%=AS% THEN POINTS%(A%)=POINTS%(A%)+1:POINTS%(H%)=POINTS%(H%)+1:DRAWS%(A%)=DRAWS%(A%)+1:DRAWS%(H%)=DRAWS%(H%)+1
570 REM ++++++++ SORT FOR NEW TABLE ++++++++
580 FOR B=1 TO NUM
590 FOR A=1 TO NUM-1
600 C=POSITION%(A):D=POSITION%(A+1)
610 IF POINTS%(C)<POINTS%(D) THEN E=D:POSITION%(A+1)=POSITION%(A):POSITION%(A)=E
620 IF SEP%=1 AND POINTS%(C)=POINTS%(D) AND (GFOR%(C)-GAGAINST%(C))=(GFOR%(D)-GAGAINST%(D)) THEN IF GFOR%(C)-GAGAINST%(C)<GFOR%(D)-GAGAINST%(D) THEN E=D:POSITION%(A+1)=POSITION%(A):POSITION%(A)=E
630 IF SEP%=2 AND POINTS%(C)=POINTS%(D) AND GFOR%(C)<GFOR%(D) THEN E=D:POSITION%(A+1)=POSITION%(A):POSITION%(A)=E
640 NEXT A,B
650 REM ++++++++  LEAGUE TABLE  ++++++++
660 CLS
670 IF NUM<22 THEN COLOR 15:LOCATE 1,(80-LEN(LEAGUE$))/2-2:PRINT LEAGUE$
680 IF LEAGUE%<22 THEN LOCATE 3,42:COLOR 2:PRINT "P   W   D   L   F   A  PTS" ELSE LOCATE 1,42:COLOR 2:PRINT "P   W   D   L   F   A  PTS"
690 COLOR 10
700 FOR A=1 TO NUM
710 IF POSITION%(A)=TEAM% THEN COLOR 15 ELSE COLOR 10
720 IF NUM<22 THEN B=4+A ELSE B=A
730 LOCATE B,6:PRINT A
740 LOCATE B,41
750 PRINT WINS%(POSITION%(A))+DRAWS%(POSITION%(A))+LOSSES%(POSITION%(A))
760 LOCATE B,10:PRINT TEAM$(POSITION%(A))
770 LOCATE B,45:PRINT WINS%(POSITION%(A))
780 LOCATE B,49:PRINT DRAWS%(POSITION%(A))
790 LOCATE B,53:PRINT LOSSES%(POSITION%(A))
800 LOCATE B,57:PRINT GFOR%(POSITION%(A))
810 LOCATE B,61:PRINT GAGAINST%(POSITION%(A))
820 LOCATE B,65:PRINT POINTS%(POSITION%(A))
830 NEXT A
840 WHILE INKEY$="":WEND
850 REM ++++++++ WORKING SCREEN ++++++++
860 CLS:COLOR 5:LOCATE 5,33:PRINT "LEAGUE TRACKER":LOCATE 6,33:PRINT "------ -------"
870 COLOR 10:LOCATE 8,5:PRINT "1   - + - + - + -   Add a result to the league"
880 LOCATE 9,5:PRINT "2   - + - + - + -   View the current league"
890 LOCATE 10,5:PRINT "3   - + - + - + -   Save current league to disk"
900 LOCATE 11,5:PRINT "4   - + - + - + -   Load a previously saved league for use"
910 LOCATE 12,5:PRINT "5   - + - + - + -   Go to options menu"
920 A$=INKEY$:IF A$="" THEN GOTO 920
930 IF VAL(A$)>5 OR VAL(A$)<1 THEN GOTO 920
940 ON VAL(A$) GOTO 950,650,1070,400,1190
950 REM ++++++++ ENTER A RESULT ++++++++
960 CLS:COLOR 5:LOCATE 5,33:PRINT "ENTER A RESULT":LOCATE 6,33:PRINT "----- - ------"
970 COLOR 10:LOCATE 8,5:PRINT "TEAMS : ";:COLOR 7:FOR A=1 TO NUM:PRINT TEAM$(A);", ";:NEXT A
980 PRINT:PRINT:COLOR 10:INPUT "     Enter the home team : ";H$
990 INPUT "     Enter their score : ";HS%
1000 INPUT "     Enter the away team : ";A$
1010 INPUT "     Enter their score : ";AS%
1020 IF H$=A$ THEN GOTO 950
1030 H%=0:A%=0:FOR A=1 TO NUM:IF H$=TEAM$(A) THEN H%=A ELSE IF A$=TEAM$(A) THEN A%=A
1040 NEXT A
1050 IF A%=0 OR H%=0 THEN GOTO 950
1060 GOTO 510
1070 REM ++++++++ SAVE THE CURRENT LEAGUE ++++++++
1080 CLS
1090 LOCATE 2,30:PRINT "SAVE THE CURRENT LEAGUE"
1100 LOCATE 5,5:INPUT "Enter filename :",F$
1110 IF LEN(F$)>8 OR F$="" THEN GOTO 1080
1120 LOCATE 7,5:PRINT "Opening league file"
1130 OPEN F$+".SVD" FOR OUTPUT AS #1
1140 PRINT #1,LEAGUE$:PRINT #1,NUM:PRINT #1,SEP%
1150 FOR A=1 TO NUM:PRINT #1,TEAM$(A):PRINT #1,WINS%(A):PRINT #1,DRAWS%(A):PRINT #1,LOSSES%(A):PRINT #1,POINTS%(A):PRINT #1,GFOR%(A):PRINT #1,GAGAINST%(A):PRINT #1,POSITION%(A):NEXT A
1160 CLOSE
1170 GOTO 850
1180 LOCATE 2,30:PRINT "RETSTART THE PROGRAMGUE"
1190 REM ********* RETURN TO MENU POSER
1200 CLS
1210 COLOR 12:PRINT:PRINT:PRINT "          Do you want to 1. Run again or":PRINT "                         2. Return to program":PRINT "                         3. Return to DOS"
1220 LOCATE 3,26:COLOR 7:PRINT "1"
1230 LOCATE 4,26:PRINT "2"
1240 LOCATE 5,26:PRINT "3"
1250 A$=INKEY$:IF A$="" THEN GOTO 1250
1260 IF A$="1" THEN CLEAR:RUN
1270 IF A$="2" THEN GOTO 850
1280 IF A$="3" THEN CLS:SYSTEM
1290 GOTO 1250
