10 REM GRAPHICS 4 : 3D SOLID GRAPHS
20 REM Written by A.Sill
30 REM In GWBASIC
40 REM (c) 1992
50 REM
60 SCREEN 9:CLS
70 A$="GRAPHICS 4 : 3D SOLID GRAPHS"
80 COLOR 2
90 LOCATE 2,(80-LEN(A$))/2:PRINT A$
100 COLOR 10
110 COLOR 10:LOCATE 5,1:PRINT "    Graphs are boring aren't they ? So to spice them up and make them look even vaguely interesting, we have a program to show 3D graphs - resembling a piece of";
120 PRINT "paper or a landscape if you like. Five different graphs are included to show youtheir aesthetic potential."
130 PRINT "    The sub-routine involved could be adapted quite easily to within your own   programs, since the terrain solely depends upon ONE formula."
140 RAND=0
150 LOCATE 20,33:COLOR 12:PRINT "Press any key"
160 A$=""
170 A$=INKEY$:RAND=RAND+.1:IF A$="" THEN 170
180 RAND=RAND-VAL(RIGHT$(TIME$,2))
190 RANDOMIZE RAND
200 REM
210 DEFINT A-J,L-Z
220 DIM G(21,21)
230 GRAPH=1
240 CLS
250 LOCATE 1,1:PRINT "GRAPH ";GRAPH
260 LOCATE 2,1:PRINT "Please Wait"
270 FOR X=0 TO 21
280 FOR Y=0 TO 21
290 N=20-X:M=20-Y
300 KH=36
310 IF GRAPH=6 THEN PRINT "That's All Folks !":STOP
320 ON GRAPH GOSUB 680,710,740,770,800
330 NEXT:NEXT
340 LOCATE 2,1:PRINT "           "
350 FOR X=20 TO 1 STEP -1
360 FOR Y=20 TO 1 STEP -1
370 XX=-X*16+Y*16
380 YY=X*8+Y*8
390 X(1)=-16:X(2)=0:X(3)=16:X(4)=0
400 Y(1)=G(X+1,Y):Y(3)=G(X,Y+1)
410 Y(2)=8+G(X+1,Y+1)
420 Y(4)=G(X,Y)-8
430 GOSUB 470
440 NEXT Y,X
450 WHILE INKEY$="":WEND
460 GRAPH=GRAPH+1:IF GRAPH = 6 THEN GOTO 830 ELSE GOTO 240
470 F=0:AX=0:AY=0:G=20:H=20
480 COL=7
490 FLAG=0
500 GOSUB 630
510 BY=AY:BX=AX
520 AY=AY/4:AX=AX/4
530 N=0:F1=0
540 PSET (AX+320+XX,AY+YY-16),0
550 AY1=INT(Y(2)+Y(4))/2
560 PAINT (320+XX,AY1+YY-16),7
570 FLAG=1
580 COL=7:GOSUB 630
590 F=0:FOR A=1 TO 5:N=A:IF N=5 THEN N=1
600 IF F=0 THEN F=1:PSET (X(N)+320+XX,Y(N)+YY-16),COL ELSE LINE -(X(N)+XX+320,Y(N)+YY-16)
610 NEXT A
620 RETURN
630 FOR A=1 TO 5:N=A:IF N=5 THEN N=1
640 IF FLAG=1 THEN AY=BY:AX=BX
650 IF F=0 THEN F=1:PSET (X(N)+XX+320,Y(N)+YY-16),COL ELSE LINE -(X(N)+XX+320,Y(N)+YY-16),COL:AX=AX+X(N):AY=AY+Y(N)
660 NEXT A
670 RETURN
680 REM GRAPH 1 A SIMPLE WIDE SINE CURVE
690 G(X,Y)=KH+SIN(X/2)*8
700 RETURN
710 REM WAVEY DAVEY CURVE 2
720 KH=36:G(X,Y)=SIN(X)*COS(Y)*7
730 RETURN
740 REM CORRUGATED IRON CURVE THINGY
750 G(X,Y)=SIN(Y*5)^3*10
760 RETURN
770 REM RIDGE LAND PLATEAU (?)
780 G(X,Y)=(Y=X OR Y=X-1 OR Y=X+1)*10+(Y=1)*20
790 RETURN
800 REM
810 G(X,Y)=X*3+(INT(X/2)=X/2)*-5
820 RETURN
830 REM ********* RETURN TO MENU POSER
840 CLS
850 COLOR 12:PRINT:PRINT:PRINT "          Do you want to 1. Run again or":PRINT "                         2. Return to DOS ?."
860 LOCATE 3,26:COLOR 7:PRINT "1"
870 LOCATE 4,26:PRINT "2"
880 A$=INKEY$:IF A$="" THEN GOTO 880
890 IF A$="1" THEN CLEAR:RUN
900 IF A$="2" THEN CLS:SYSTEM
910 GOTO 880
